// Compile "NT character-mode executable" with  WATCOM C/C++ 11.0
// or with BC++ 3.1 Small MODEL, Signed Chars
#ifdef _GNU_SOURCE
 #include <stdio.h>
 #define SWITCHCHAR0 '-'
 #define SWITCHCHAR1 '-'
#else
 #define SWITCHCHAR0 '-'
 #define SWITCHCHAR1 '/'
 #include <io.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <process.h>
 #include <string.h>
 #include <conio.h>
 #include <dos.h> // BC++ 3.1 def. __DOS_H - using as DOS_16 flag
#endif

#ifdef __DOS_H
 #include <dir.h>
 #define __DOS16__
 #define bufSize1 32768L
 #define bufSize2 8192L
 #define maxFName 255
#else
 //#include <sys/utime.h>
 #define bufSize1 4*1024*1024
 #define bufSize2 1024*1024
 #define maxFName 4095
#endif

unsigned long numOfBuf2InBuf1 = (bufSize1) / (bufSize2);
unsigned long bufSize_1 = 0;
unsigned long bufSize_2 = 0;
char fnameInp1[maxFName];
char fnameInp2[maxFName];
char tmpString[maxFName];
char buf1[bufSize1];
char buf2[bufSize2];
unsigned int i;
FILE *hndlInp1 = NULL, *hndlInp2 = NULL;
int optionVerbose  = 0; //int optionQuiet = 0;
int optionSyncBegSeq = 0;
unsigned long maxNumOfDiffs = 0xffffffff;
unsigned long fbegInp1 = 0, fbegInp2 = 0;
unsigned long flenInp1 = 0, flenInp2 = 0;
unsigned long differs = 0;

unsigned char inHex[256] = {
/*00*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*10*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*20*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*30*/  0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 ,255,255,255,255,255,255,
/*40*/ 255,10 ,11 ,12 ,13 ,14 ,15 ,255,255,255,255,255,255,255,255,255,
/*50*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*60*/ 255,10 ,11 ,12 ,13 ,14 ,15 ,255,255,255,255,255,255,255,255,255,
/*70*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*80*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*90*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*A0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*B0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*C0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*D0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*E0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*F0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255
};

void logoAndVersion(void) {
    printf("\n\
  VFCADV: VIT(R) Binary File Comparer Advanced\n\
  Version 1.0  Copyright (C) Vitaliy I. Vasiliev 22.01.2000\n\
  Vitaliy Vasiliev homepage: http://www.chat.ru/~vitaliy_vasiliev/\n\
  Vitaliy Vasiliev homepage mirror: http://free.prohosting.com/~vitivas/\n\
");
}

void usage(void) {
    logoAndVersion();
    printf("\n\
  Usage: VFCADV [switches] InputFname1 InputFname2\n\
  switches:\n\
    -l1$XXXXXXXX - buffer1len: 1...0x%lX bytes (default 0x%lX)\n\
    -l2$XXXXXXXX - buffer2len: 1...0x%lX bytes (default 0x%lX)\n\
    -b1$XXXXXXXX - file 1 beg (default 0)\n\
    -b2$XXXXXXXX - file 2 beg (default 0)\n\
    -n$XXXXXXXX  - stop after n numer of diffs (default 0xffffffff)\n\
    -v           - Verbose output\n\
    -s           - Sync beginning search in first [buffer2len] bytes\n\
    -?, -h       - this help message\n\
  ", bufSize1, bufSize1, bufSize2, bufSize2);
    exit(127);
//   -d            - generate dependencies
//   -l            - output listing to file
//   -q            - quiet mode
//   -e<n>         - stop after n errors
//   -w<n>         - stop after n warnings
//   -b<dir_name>  - add #binary<> search path
//   -i<dir_name>  - add #include<> search path
//   -o<file_name> - set target OBJ filename
}

unsigned long getArgVal(char* ptrSrc) {
    char *ptrStart;
    unsigned long val = 0;
    ptrStart = ptrSrc;

    if(*ptrSrc == 0) {
        printf("\nError in arguments: constant value expected.\n");
        exit(-1);
    }
    if((*(unsigned short *)ptrSrc != '0' + 256 * 'x') && (*ptrSrc != '$')) {
        while(*ptrSrc >= '0' && *ptrSrc <= '9') {
            val *= 10;
            val += (unsigned long)(*(ptrSrc++) - '0');
        }
    } else { // if beg "0x" or "$" ==> hexadecimal
        ptrSrc++;
        if(*ptrSrc == 'x') ptrSrc++;
        ptrSrc--;
        while(inHex[*++ptrSrc] < 0x10) {
            val *= 0x10;
            val += (unsigned long)(inHex[*ptrSrc]);
        }
    }
    if(*ptrSrc != 0) {
        printf("\ninvalid constant value: '%s'\n",ptrStart);
        exit(-1);
    }
    return(val);
}

void pause(void) {
#ifndef _GNU_SOURCE
    #define Esc 0x001B
    unsigned int pausekey = 0;
    fprintf(stderr, "press any key to continue, ESC to exit...");
    while(!pausekey) {
        if(kbhit()) { // check for pressing ESCAPE
            if((pausekey = getch()) == 0)  pausekey = getch() * 256;
            if(pausekey == Esc) {
                printf("\n*** Exiting by ESCAPE ***\n");
                exit(255);
            }
        }
    }
    fprintf(stderr, "\r                                         \r");
#endif
}

void frdChk(char* frdBuf, unsigned long frdLen, FILE* frdHndl, char* frdName) {
    if((fread(&frdBuf[0], frdLen, 1, frdHndl)) != 1) {
        printf("Unexpected EOF or error reading file '%s'\n", frdName);
        exit(255);
    }
}

void fwrChk(char* fwrBuf, unsigned long fwrLen, FILE* fwrHndl, char* fwrName) {
    if((fwrite(&fwrBuf[0], fwrLen, 1, fwrHndl)) != 1) {
        printf("Error writing file '%s'\n", fwrName);
        exit(255);
    }
}

unsigned long getArg(char *outStr, char *argv[], char *argN, char *dflt) {
    // if(outStr == NULL) get argument/switch value
    // 'argN' is argument number ("1", "2",..."99") or switch name ("-q", "-b")
    // 'dflt' is default returning value - use NULL if value must be defined
    //  in command line
    // will be returned pointer:
    //  for arg              - pointer to arg or 'dflt' if arg not def. in
    //                         command line and dflt!=NULL
    //  for arg=value        - pointer to "value" or pointer to 'dflt'
    //  for arg:value        - pointer to "value" or pointer to 'dflt'
    //  for swith as -q[Y|N] - pointer to cahr after "-q" or 'dflt' if switch
    //                         not def. in command line
    //  for swith as -b1234  - pointer to "1234" or pointer to 'dflt'
    //  for swith as -b=1234 - pointer to "1234" or pointer to 'dflt'
    //  for swith as -b 1234 - pointer to "1234" (next non-switch command line
    //                         arg) or pointer to 'dflt'
    unsigned long retVal = 0;
    char *outPtr = dflt;
    int a = 0;
    int i = 0;
    int an = -1;
    if(argN[0] == '-') { // if switch
        for(an = 0; argN[an + 1] != 0; an++) ;
        for(a = 1; argv[a] != NULL; a++) { // for every command line arg
            if(argv[a][0] == SWITCHCHAR0 || argv[a][0] == SWITCHCHAR1) {
                for(i = 0; i < an; i++) if(argv[a][i + 1] != argN[i + 1]) break;
                if(i != an) continue;
                break;
            } else { // if argument - may be "switch=value" - checking:
                for(i = 0; i < an; i++) if(argv[a][i] != argN[i + 1]) break;
                if(i != an) continue;
                if(argv[a][i] != ':') continue;
                if(argv[a][i] != '=') continue;
                printf("switch=value: argv[a]=%s\n", argv[a]);
                pause();
                continue;
            }
        }
        if(argv[a] != NULL) {
            i++;
            if(argv[a][i] == ':') i++;
            if(argv[a][i] == '=') i++;
            outPtr = &argv[a][i];
            if(outStr == NULL && argv[a][0] == '-' && (argv[a][1] == 'q' || argv[a][1] == 'Q') && argv[a][2] == 0) return 1;
            if(optionVerbose) printf("accept CmdLn switch %s", argN);
            if(outStr == NULL && dflt[1] == 0 && dflt[0] == '+') { if(optionVerbose) printf("\n"); return 1; }
            if(outStr == NULL && dflt[1] == 0 && dflt[0] == '-') { if(optionVerbose) printf("\n"); return 0; }
        } else {
            if(outStr == NULL && dflt[1] == 0 && dflt[0] == '+') return 0;
            if(outStr == NULL && dflt[1] == 0 && dflt[0] == '-') return 1;
            if(optionVerbose) printf("absent CmdLn switch %s", argN);
            if(outPtr == NULL) {
                printf("\n Error in command line arguments: must be defined argunment %s.\n", argN);
                usage(); // and exit();
            } else {
                if(optionVerbose) printf(": using default");
            }
        }
        if(outStr == NULL) {
            retVal = getArgVal(outPtr);
            if(optionVerbose) printf(": val %ld (0x%lX) parsed \"%s\"\n", retVal, retVal, outPtr);
            return retVal;
        }
        strcpy(outStr, outPtr);
        if(optionVerbose) printf(": str \"%s\"\n", outStr);
        return 0;
    } else { // find (an)-argument
        an = getArgVal(argN);
        for(a = 1; argv[a] != NULL; a++) { // for every command line arg
            if(argv[a][0] == SWITCHCHAR0) continue; // skip switch
            if(argv[a][0] == SWITCHCHAR1) continue; // skip switch
            if(--an == 0) break;
        }
        if(an == 0) {
            outPtr = argv[a];
            if(optionVerbose) printf("accept CmdLn argument %s", argN);
        } else {
            if(optionVerbose) printf("absent CmdLn argument %s", argN);
            if(outPtr == NULL) {
                printf("\n Error in command line arguments: must be defined argunment %s.\n", argN);
                usage(); // and exit();
            } else {
                if(optionVerbose) printf(": using default");
            }
        }
        if(outStr == NULL) {
            retVal = getArgVal(outPtr);
            if(optionVerbose) printf(": val %ld (0x%lX) parsed \"%s\"\n", retVal, retVal, outPtr);
            return retVal;
        }
        strcpy(outStr, outPtr);
        if(optionVerbose) printf(": str \"%s\"\n", outStr);
        return -1;
    }
}

int checkStringsEq(char *s1, char *s2, unsigned long len) {
    int i;
    for(i = 0; i < len; i++) if(s1[i] != s2[i]) return 1;
    return 0;
}

int checkStringsEq2(char *s1, char *s2, unsigned long len1, unsigned long len2) {
    if(len1 > len2) len1 = len2;
    return(checkStringsEq(s1, s2, len1));
}

int compareStrings(char *s1, char *s2, unsigned long len1, unsigned long len2, unsigned long fptr1, unsigned long fptr2) {
    int i;
    if(len1 > len2) len1 = len2;
    len2 = 0;
    for(i = 0; i < len1; i++) if(s1[i] != s2[i]) {
        if(fptr1 == fptr2) printf("%08lX: %02X %02X\n", fptr1 + i, (int)s1[i]&0xff, (int)s2[i]&0xff);
        else               printf("%08lX: %02X %02X :%08lX\n", fptr1 + i, (int)s1[i]&0xff, (int)s2[i]&0xff, fptr2 + i);
        len2++;    // number of different bytes in this portion
        differs++; // number of different bytes
        if(!--maxNumOfDiffs) { printf("Too many diffrent bytes - stopping comparition, exiting.\n"); exit(5); }
    }
    return len2;
}

int main(int argc, char *argv[]) {
    unsigned long var1 = 0;
    unsigned long var2 = 0;
    unsigned long var = 0;
    unsigned long rst1 = 0;
    unsigned long rst2 = 0;
    unsigned long fptr1 = 0;
    unsigned long fptr2 = 0;
    unsigned long i = 0;
    int flag1stNeedsRead = 1;
    argc++; argc--;
    //optionQuiet |= getArg(NULL, argv, "-q", "+");
    //optionQuiet |= getArg(NULL, argv, "-Q", "+");
    optionVerbose |= getArg(NULL, argv, "-v", "+");
    optionVerbose |= getArg(NULL, argv, "-V", "+");

    if(getArg(NULL, argv, "-?", "+")) usage();
    if(getArg(NULL, argv, "-h", "+")) usage();
    if(getArg(NULL, argv, "-H", "+")) usage();

    getArg(fnameInp1, argv, "1", NULL);
    getArg(fnameInp2, argv, "2", NULL);

    fbegInp1 = getArg(NULL, argv, "-b1", "0");
    fbegInp2 = getArg(NULL, argv, "-b2", "0");

    sprintf(tmpString, "%ld", (long)bufSize1);
    bufSize_1 = getArg(NULL, argv, "-l1", tmpString);
    sprintf(tmpString, "%ld", (long)bufSize2);
    bufSize_2 = getArg(NULL, argv, "-l2", tmpString);
    maxNumOfDiffs = getArg(NULL, argv, "-n", "0xffffffff");
    optionSyncBegSeq |= getArg(NULL, argv, "-s", "+");
    optionSyncBegSeq |= getArg(NULL, argv, "-S", "+");

    if(bufSize_1 > bufSize1) bufSize_1 = bufSize1;
    if(bufSize_2 > bufSize2) bufSize_2 = bufSize2;
    numOfBuf2InBuf1 = bufSize_1 / bufSize_2;
    if(numOfBuf2InBuf1 == 0) numOfBuf2InBuf1 = 1;
    bufSize_1 = numOfBuf2InBuf1 * bufSize_2;
    if(optionVerbose) printf("Using bufSize_1=0x%lX bufSize_2=0x%lX\n", bufSize_1, bufSize_2);

    if((hndlInp1 = fopen(fnameInp1, "rb")) == NULL) {
        printf("Can't open for read file: '%s'\n", fnameInp1);
        exit(255);
    }
    if((hndlInp2 = fopen(fnameInp2, "rb")) == NULL) {
        printf("Can't open for read file: '%s'\n", fnameInp2);
        exit(255);
    }

    var1 = bufSize_1;
    var2 = bufSize_2;

    fseek(hndlInp1, 0, SEEK_END);
    flenInp1 = ftell(hndlInp1);
    fseek(hndlInp1, fbegInp1, SEEK_SET);

    fseek(hndlInp2, 0, SEEK_END);
    flenInp2 = ftell(hndlInp2);
    fseek(hndlInp2, fbegInp2, SEEK_SET);

    if(optionVerbose) printf("File1 ('%s') length = %ld (0x%lX) bytes\n", fnameInp1, flenInp1, flenInp1);
    if(optionVerbose) printf("File2 ('%s') length = %ld (0x%lX) bytes\n", fnameInp2, flenInp2, flenInp2);

    if(flenInp1 == 0) { printf("File1 ('%s') has length 0 - not enought bytes to compare :(\n", fnameInp1); exit(7); }
    if(flenInp2 == 0) { printf("File2 ('%s') has length 0 - not enought bytes to compare :(\n", fnameInp2); exit(8); }

    if(flenInp1 < var1) var1 = flenInp1;
    if(flenInp2 < var2) var2 = flenInp2;
    var = var1;
    if(var > var2) var = var2;
    if(optionSyncBegSeq) {
        if(optionVerbose) printf("optionSyncBegSeq - proc\n", var);
        frdChk(buf1, var1, hndlInp1, fnameInp1);
        frdChk(buf2, var2, hndlInp2, fnameInp2);
        flag1stNeedsRead = 0;
        if(checkStringsEq(buf1, buf2, var)) {
            if(optionVerbose) printf("Different bytes found in first %ld bytes\n", var);
            if(optionVerbose) printf("Trying to sync beg seq...\n", var);
            for(i = 0; i < var/2; i++) {
                if(!checkStringsEq2(&buf1[i], buf2, var1 - i, var2)) {
                    var = var1 - i;
                    if(var > var2) var = var2;
                    if(optionVerbose) printf("Found equals: File2 ('%s') from 0 equals File1 ('%s') from %ld (0x%lX) equalsLength=%ld (0x%lX) bytes\n", fnameInp2, fnameInp1, i, i, var, var);
                    fbegInp1 += i;
                    if(optionVerbose) printf("Setting new fbegInp1=%ld (0x%lX)\n", fbegInp1, fbegInp1);
                    for(fptr1 = i; fptr1 < var1; fptr1++) buf1[fptr1 - i] = buf1[fptr1];
                    frdChk(&buf1[var1 - i], i, hndlInp1, fnameInp1);
                    break;
                }
                if(!checkStringsEq2(buf1, &buf2[i], var1, var2 - i)) {
                    var = var2 - i;
                    if(var > var1) var = var1;
                    if(optionVerbose) printf("Found equals: File1 ('%s') from 0 equals File2 ('%s') from %ld (0x%lX) equalsLength=%ld (0x%lX) bytes\n", fnameInp1, fnameInp2, i, i, var, var);
                    fbegInp2 += i;
                    if(optionVerbose) printf("Setting new fbegInp2=%ld (0x%lX)\n", fbegInp2, fbegInp2);
                    for(fptr2 = i; fptr2 < var2; fptr2++) buf2[fptr2 - i] = buf2[fptr2];
                    frdChk(&buf2[var2 - i], i, hndlInp2, fnameInp2);
                    break;
                }
            }
        } else {
            if(optionVerbose) printf("No different bytes found in first %ld bytes\n", var);
        }
    }

    printf("Comparing files %s and %s\n", fnameInp1, fnameInp2);
    if(optionVerbose || fbegInp1 || fbegInp2) printf("\nNow comparing:\n File1 ('%s') from %ld (0x%lX)\n File2 ('%s') from %ld (0x%lX).\n\n", fnameInp1, fbegInp1, fbegInp1, fnameInp2, fbegInp2, fbegInp2);

    //fseek(hndlInp1, fbegInp1, SEEK_SET);
    //fseek(hndlInp2, fbegInp2, SEEK_SET);

    fptr1 = fbegInp1;
    fptr2 = fbegInp2;

    var = flenInp1 - fbegInp1;
    if(var > flenInp2 - fbegInp2) var = flenInp2 - fbegInp2;
    rst1 = var;
    rst2 = var;
    for(;;) {
        if(rst1 > bufSize_1) var = bufSize_1;
        else                 var = rst1;
        if(flag1stNeedsRead) frdChk(buf1, var, hndlInp1, fnameInp1);
        for(i = 0; i < numOfBuf2InBuf1; i++) {
            if(rst2 > bufSize_2) var = bufSize_2;
            else                 var = rst2;
            if(flag1stNeedsRead) frdChk(buf2, var, hndlInp2, fnameInp2);
            flag1stNeedsRead = 1;
            compareStrings(&buf1[i*bufSize_2], buf2, var, rst1, fptr1, fptr2);
            rst1 -= var;
            rst2 -= var;
            fptr1 += var;
            fptr2 += var;
            if(rst1 == 0) break;
            if(rst2 == 0) break;
        }
        if(rst1 == 0) break;
        if(rst2 == 0) break;
    }
    if(optionVerbose) printf("End comparing: File1 ('%s') at 0x%lX and File2 ('%s') at 0x%lX\n", fnameInp1, ftell(hndlInp1), fnameInp2, ftell(hndlInp2));

    if(fbegInp1 == 0 && fbegInp2 == 0 && differs == 0 && flenInp1 == flenInp2) {
        printf("FC: no differences encountered\n\n");
        exit(0);
    }
    if(fbegInp1 == 0 && fbegInp2 == 0 && differs == 0) {
        if(flenInp1 > flenInp2) { printf("FC: %s longer than %s by %ld (0x%lX) bytes\n\n", fnameInp1, fnameInp2, flenInp1 - flenInp2, flenInp1 - flenInp2); exit(1); }
        if(flenInp2 > flenInp1) { printf("FC: %s longer than %s by %ld (0x%lX) bytes\n\n", fnameInp2, fnameInp1, flenInp2 - flenInp1, flenInp2 - flenInp1); exit(2); }
        printf("Internal error: assertion failed: flenInp1 == flenInp2\n");
        pause();
        exit(254);
    }
    if(fbegInp1 == 0 && fbegInp2 == 0) {
        printf(" %ld (0x%lX)", differs, differs);
        printf(" differences encountered\n\n", fptr1 - fbegInp1, fptr1 - fbegInp1);
        exit(9);
    }

    printf("In compared part:\n");
    printf(" File1 ('%s') from %ld (0x%lX) to", fnameInp1, fbegInp1, fbegInp1);
    if(fptr1 == flenInp1) printf(" EOF");
    printf(" %ld (0x%lX)\n", fptr1, fptr1);
    printf(" File2 ('%s') from %ld (0x%lX) to", fnameInp2, fbegInp2, fbegInp2);
    if(fptr2 == flenInp2) printf(" EOF");
    printf(" %ld (0x%lX)\n", fptr2, fptr2);

    if(differs == 0) printf(" no");
    else             printf(" %ld (0x%lX)", differs, differs);
    printf(" differences encountered in %ld (0x%lX) bytes compared part\n\n", fptr1 - fbegInp1, fptr1 - fbegInp1);
    if(fptr1 < flenInp1) printf("Note: File1 (%s) has extra %ld (0x%lX) bytes after compared part\n", fnameInp1, flenInp1 - fptr1, flenInp1 - fptr1);
    if(fptr2 < flenInp2) printf("Note: File2 (%s) has extra %ld (0x%lX) bytes after compared part\n", fnameInp2, flenInp2 - fptr2, flenInp2 - fptr2);
    if(differs == 0) exit(3);
    exit(4);
    return 0;
}
